#include <iostream>
#include <bitset>
using namespace std;

long long cnk(long long n, long long k){
    long long res = 1;
    if(k == 0) return 0;
    for(int i=0;i<k;i++){
        res *= (n - i);
        res /= i + 1;
    }

    return res;
}

int main(){
    int n, m;
    long long k;

    cin>>n>>m>>k;


    long long v[65];
    for(int i=0;i<65;i++){
        v[i] = 0;
    }

    v[0] = 1;

    bitset<64> b(k);

    long long bb = -1;
    for(int s = 63;s >= 0; s--){
        if(b[s]){
            bb++;
            for(int i=0;i<=s;i++){
                v[bb + i] += cnk(s, i);
            }
            v[bb+1]++;
        }
    }

    long long res = 1;

    for(int i=1;i<=64;i++){
        long long cv = v[i];
        for(int j=0;j<i;j++){
            cv *= n;
        }
        cv %= 1000000007;
        res += cv;
        res %= 1000000007;
    }

    cout<<res;
}
