#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

vector<int> m[300000];
bool was[300000];
int n;

pair<int, int> dfs(int v){
    was[v] = true;

    pair<int, int> p(1, 0);
    for(int i = 0; i < m[v].size(); i++){
        int to = m[v][i];
        if(!was[to]){
            pair<int, int> r = dfs(to);
            p.second += max( r.first, r.second );
            p.first += r.second;
        }
    }

    return p;
}

int main(){

    cin>>n;

    for(int i=0;i<n;i++){
        int x;
        cin>>x;
        if(x == -1) continue;
        m[i].push_back(x-1);
        m[x-1].push_back(i);
    }

    int res = 0;
    for(int i=0;i<n;i++){
        if(!was[i]){
            pair<int, int> a = dfs(i);
            res += max(a.first, a.second);
        }
    }

    cout<<res;

}

