#include <iostream>
#include <cmath>
using namespace std;

#define ABS(x) ( ((x)>0)?(x):-(x) )

int main(){

    long long n;
    cin>>n;

    bool minus = false;

    if(n < 0){
        minus = true;
        n *= -1;
    }

    if(n == 0){
        cout<<"0\n";
        return 0;
    }

    long long res = -1;

    long long mx = sqrt(n)  + 2;

    for(long long p = 1; p <= mx; p++){
        if(n % p == 0){
            long long q = n / p;
            if(p % 2 == q % 2){
                long long t = minus?(p + q):(p-q);

                t /= 2;
                if(t < 0) t *= -1;

                if(minus){
                    t = min(ABS(t - p), ABS(t - q));
                }

                else{
                    t = min(ABS( t + p), ABS(t + q));
                }

                if(res > t || res == -1) res = t;
            }
        }
    }

    if(res == -1){
        cout<<"none\n";
        return 0;
    }

    cout<<res<<'\n';
    return 0;

}
